VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1545
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1545
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSearch 
      Caption         =   "Search"
      Height          =   375
      Left            =   1920
      TabIndex        =   4
      Top             =   840
      Width           =   855
   End
   Begin VB.TextBox txtSearch 
      Height          =   285
      Left            =   960
      TabIndex        =   3
      Text            =   "u"
      Top             =   480
      Width           =   3615
   End
   Begin VB.TextBox txtText 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Text            =   "The quick brown fox jumps over the lazy dog."
      Top             =   120
      Width           =   3615
   End
   Begin VB.Label lblPos 
      Alignment       =   2  'Center
      Height          =   255
      Left            =   1920
      TabIndex        =   5
      Top             =   1320
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Search For"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Text"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdSearch_Click()
Dim pos As Integer

    pos = vb5InstrRev(txtText.Text, txtSearch.Text)
    lblPos.Caption = pos

    If pos = 0 Then
        txtText.SelStart = 0
        txtText.SelLength = 0
    Else
        txtText.SelStart = pos - 1
        txtText.SelLength = Len(txtSearch.Text)
    End If

    txtText.SetFocus
End Sub

'********************************************
'Author: Christopher McGrath <cmcgrath2@csc.com>
'
'PURPOSE: Implements InStrRev functionality in
'VB5, whereby you can begin searching for
'a character sequence within a string from the
'end rather than the beginning

'PARAMETERS:  StringCheck: String expression being searched.

'             StringMatch: String expression being searched for

'             Start (Optional) starting position for each
'             search. If omitted, search begins at the last
'             character position. Starting position is calculated
'             from the beginning of StringCheck

'             Compare (Optional) kind of comparison to use;
'             defaults to vbBinaryCompare
'             Search begins at end of string

'EXAMPLE:     debug.print(vb5InstrRev("www.freevbcode.com", ".")
'             outputs 15, wherease inStr returs 4

'NOTE:        For VB6 and above, use the built-in InStrRev
'             Function, not this
'**************************************************************
Public Function vb5InstrRev(ByVal StringCheck As String, StringMatch As String, Optional Start As Long = -1, Optional Compare As VbCompareMethod = vbBinaryCompare) As Long
Dim lStartPoint As Long
Dim lEndPoint As Long
Dim lSearchLength As Long
Dim lCtr As Long
Dim sWkg As String

    vb5InstrRev = 0

    If Len(StringMatch) > Len(StringCheck) Then Exit Function
    If Start < -1 Or Start = 0 Or Start > Len(StringCheck) Then Exit Function

    lSearchLength = Len(StringMatch)
    lStartPoint = IIf(Start = -1, Len(StringCheck), Start)
    lEndPoint = 1

    For lCtr = lStartPoint To lEndPoint Step -1
        sWkg = Mid(StringCheck, lCtr, lSearchLength)
        If StrComp(sWkg, StringMatch, Compare) = 0 Then
            vb5InstrRev = lCtr
            Exit Function
        End If
    Next lCtr
End Function
